sealed class CLXResult<T> {
  const CLXResult();

  const factory CLXResult.succ(T value) = CLXSucc._;

  const factory CLXResult.fail(Exception error) = CLXFail._;
}

final class CLXSucc<T> extends CLXResult<T> {
  const CLXSucc._(this.value);

  final T value;

  @override
  String toString() => 'Result<$T>.succ($value)';
}

final class CLXFail<T> extends CLXResult<T> {
  const CLXFail._(this.error);

  final Exception error;

  @override
  String toString() => 'Result<$T>.fail($error)';
}
